VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Notifier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Namespaces:
'    host    - host extension provides the following members
'       SetFrequency(float);
'       SetWindowPosition(long x,long y);

' Description must exist!


Dim g_Error
Dim ACOMTools
Dim g_WLDoc, g_WLWnd, g_fLastFreq
Dim host
Dim g_L, g_T

Public Property Get Description()
    Description = "WriteLog 10 notifier"
End Property

' Callback routines
Function Initialize()
    ' Initialize notifier
    ' Should return true/false to indicate success
    g_Error = ""
    g_fLastFreq = 0
    Initialize = True
    l = 0
    t = 0
End Function

Function Attach(App As Object)
    ' Attach to the external program or whatever is needed for regular operation
    ' Should return true/false to indicate success
    Set host = App
    Set ACOMTools = App.ACOMTools
    On Error Resume Next
    Set g_WLDoc = GetObject(, "WriteLog.Document")
    If Err.Number <> 0 Then
        g_Error = "WriteLog Document object cannot be obtained. Ensure WriteLog is running and a document is created/opened in it and retry."
        Attach = False
        Exit Function
    End If
    Dim r
    
    Set r = CreateObject("newObjects.misc.FoundWindow")
    If Err.Number <> 0 Then
        g_Error = "Cannot create newObjects window spy class - check if it is installed"
        Attach = False
        Exit Function
    End If
    Dim w
    Set w = r.SelectChildWindowsByName("WriteLog", 4)
    If w.Count = 0 Then
        g_Error = "Cannot find WriteLog window"
        Attach = False
        Exit Function
    Else
        Set g_WLWnd = w(0)
    End If
    
    Attach = True
End Function
Function GetLastError()
    ' Return string describing the last error
    GetLastError = g_Error
End Function
Function OnTimer()
    ' Called every 200ms
    Dim wlEntry
    Dim OpMode  As Integer
    Dim RxFreq  As Double
    Dim TxFreq  As Double
    Dim Split   As Integer
    Dim frq
    On Error Resume Next
    
    Set wlEntry = g_WLDoc.GetCurrentEntry
    If Err.Number <> 0 Then
        On Error GoTo 0
        Err.Raise 1, "Notifier", "Cannot get Current entry"
    End If
    
    
    wlEntry.GetLogFrequency OpMode, RxFreq, TxFreq, Split
    If Err.Number <> 0 Then
        ACOMTools.RaiseEvent "WLN ERROR", Err.Description
    End If
    frq = TxFreq / 1000

    If frq <> g_fLastFreq Then
        g_fLastFreq = frq
        host.SetFrequency g_fLastFreq
    End If
    
    ' Try to update the window position
    Dim l, t
    l = g_WLWnd.Left
    t = g_WLWnd.Top + g_WLWnd.Height
    If g_L <> l Or g_T <> t Then
        g_L = l
        g_T = t
        host.SetWindowPosition l, t
    End If
    
End Function
Function Detach()
    Set g_WLWnd = Nothing
    Set g_WLDoc = Nothing
    Set host = Nothing
End Function

